#include "SAM.h"
#include <math.h>
#include <stdio.h>

int main(void)
{
	SAM_init(-1,100);
	mp_st y, x, tt;
	int i, nmax=100;
	printf("-------------------------------------------------------------\n");
	printf("|  Computation of a root of a polynomial by Newton's method |\n");
	printf("|  with SAM                                                 |\n");
	printf("-------------------------------------------------------------\n");
	y = 0.5;
	for(i = 1;i<=nmax;i++){
		x = y;
		y = x-(sam_set_str(tt,"1.47")*pow(x,3)+sam_set_str(tt,"1.19")*pow(x,2)-sam_set_str(tt,"1.83")*x+sam_set_str(tt,"0.45"))/
		(sam_set_str(tt,"4.41")*pow(x,2)+sam_set_str(tt,"2.38")*x-sam_set_str(tt,"1.83"));
		if (fabs(x-y)<1.e-12) break;
	}
	
	printf("x(%3d) = %s\n",i-1,strp(x));
	printf("x(%3d) = %s\n",i,strp(y));
	
	SAM_end();
	return 0;
}