#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <sys/time.h>

#include "SAM.h"

using namespace std;

#define DEFAULT_SIZE 100
#define PRECISION 100


unsigned long long timestamp()
{
    struct timeval tp;
    gettimeofday(&tp, NULL);
    unsigned long long mslong = (unsigned long long) tp.tv_sec * 1000L + tp.tv_usec / 1000; //get current timestamp in milliseconds
    return  mslong;
}


int main (void)
{
	cout << "----------------------------------------------------------------" << endl;
	cout << "#  Performance test for matrix multiplications with SAM" << endl; 
	cout << "#  Matrix: " << DEFAULT_SIZE << " * " << DEFAULT_SIZE << endl;
    cout << "#  Precision: " << PRECISION << " bits." << endl;
	cout << "----------------------------------------------------------------" << endl;

	SAM_init(-1, PRECISION);
	int i,j,k;
	mp_st ** amat;
	mp_st ** res;
	mp_st tmp;
	//	int cpt=0;
	
	unsigned long long startTime = timestamp();

	amat = new mp_st*[DEFAULT_SIZE];
	for(i=0; i<DEFAULT_SIZE; i++) {
		amat[i]=new mp_st [DEFAULT_SIZE];
	}
	res = new mp_st*[DEFAULT_SIZE];
	for(i=0; i<DEFAULT_SIZE; i++) {
		res[i]=new mp_st [DEFAULT_SIZE];
	}

	for(i=0; i<DEFAULT_SIZE; i++){
		for(j=0; j<DEFAULT_SIZE; j++){
			amat[i][j] = i+1+j;
		}
	}
	
	for(i=0; i<DEFAULT_SIZE; i++){
		for(j=0; j<DEFAULT_SIZE; j++){
			res[i][j] = 0;
			for (k=0; k<DEFAULT_SIZE; k++){
				tmp = amat[i][k] * amat[k][j];
				res[i][j] += tmp;
				//			cpt++;
			}
		}
	}

	for(i=0; i<DEFAULT_SIZE; i++){
		delete[] amat[i];
		delete[] res[i];
	}
	delete[] amat;
	delete[] res;
	
	unsigned long long finishTime = timestamp();
	unsigned long durn = (unsigned long)(finishTime - startTime);

	SAM_end();

	cout << "----------------------------------------------------------------" << endl;
	cout << "# Execution took " << durn << " milliseconds." << endl;
	cout << "----------------------------------------------------------------" << endl;
	
	return 0;
}
